/*
THE FIVE ORDERS OF CLASSICAL ARCHITECTURE (version 1.0)

(C) Nathan G B O'Brien  1997

This file contains the various texture definitions for the columns contained in 13_col.inc

*/

// Column shaft
#declare T_Column1 = texture
{
  pigment
  {
    bozo
    turbulence 1.2
    color_map
    {
      [0.00 color rgb<0.894, 0.941, 0.980>]
      [0.25 color rgb<0.722, 0.792, 0.839>]
      [0.41 color rgb<1.000, 1.000, 1.000>]
      [0.58 color rgb<0.827, 0.953, 0.976>]
      [0.74 color rgb<0.831, 0.871, 0.933>]
      [1.00 color rgb<1.000, 1.000, 1.000>]
    }
  }
  finish {
    phong 1.0 
    reflection .2
  }
}

// Column flutes
#declare T_Column2 = texture
{
  pigment
  {
    granite
    turbulence 1.2
    color_map
    {
      [0.00 color rgb<0.894, 0.941, 0.980>]
      [0.25 color rgb<0.722, 0.792, 0.839>]
      [0.41 color rgb<1.000, 1.000, 1.000>]
      [0.58 color rgb<0.827, 0.953, 0.976>]
      [0.74 color rgb<0.831, 0.871, 0.933>]
      [1.00 color rgb<1.000, 1.000, 1.000>]
    }
  }
  finish {
    ambient 0.2
    phong 1.0
  }
}

// Base colour of capitals
#declare T_Column3 =
texture {pigment {
	color <1.00,0.93,0.87>
	}
  	finish {phong 0.6}
}

// Feature colour of capitals
#declare T_Column4 = texture
{
  pigment
  {
    colour rgb<0.996,0.808,0.408>
  }
  finish {
    brilliance 2.0
    phong 1.0    metallic
  }
}

// Feature colour of capitals
#declare T_Column4a = texture
{
  pigment
  {
    colour rgb<0.796,0.608,0.208>
  }
  finish {
    brilliance 2.0
    phong 1.0    metallic
  }
}


// Top plate of capitals
#declare T_Column5 =
texture {pigment {
	color <0.92,0.78,0.64>
	}
  	finish {phong 0.6}
}

// Colour of Flower feature to capital
#declare T_Column6 = texture
{
  pigment
  {
    colour rgb<0.996,0.808,0.408>
  }
  finish {
    brilliance 2.0
    phong 1.0    metallic
    reflection 0.6
  }
}

// Colour of Base
#declare T_Column7 = texture
{
  pigment
  {
    colour rgb<0.996,0.808,0.408>
  }
  finish {
    brilliance 2.0
    phong 1.0    metallic
//    reflection 0.6
  }
}

// Colour of Plinth
#declare T_Column8 =
texture {pigment {
	color <0.89,0.74,0.60>
	}
  	finish {phong 0.6}
}
