// Persistence of Vision Ray Tracer Scene Description File
// File: .inc
// Vers: 3.1
// Desc: the towers
// Date: feb 99
// Auth: Nathan O'Brien
// Mail: no13@no13.net
// Webp: www.no13.net
// Copyright: (C) Nathan G B O'Brien 1998 


// 3 radius weird ring
#declare Weird_Ring1 =
union {
	cylinder {<0,-.8,0><0,.8,0>,3.2 texture{T_13Gold1}}
	cylinder {<0,-.75,0><0,.75,0>,3.3 texture{T_13Stone2}} 
	#local Count1 = 0;
	#while (Count1 < 6)
		object {Weird_Featue scale .5 translate <0,0,-3.3> rotate <0,(Count1 * 60),0>}
		#local Count1 = (Count1 + 1);
	#end
} 

#declare Weird_Ring2 =
union {
	cylinder {<0,-1.8,0><0,1.8,0>,7.2 texture{T_13Gold1}}
	cylinder {<0,-1.5,0><0,1.5,0>,7.3 texture{T_13Stone2}}
	#local Count1 = 0;
	#while (Count1 < 6)
		object {Weird_Featue translate <0,0,-7.3> rotate <0,(Count1 * 60),0>}
		#local Count1 = (Count1 + 1);
	#end
}

//(Rad,Depth,Style,Age,Form)

#declare Tower1 = 
union {
	TW_One (7.1,500,3,.4,1)
	RT_Main (10,3,4,2.5,2) 
	
	object {Weird_Ring2 translate <0,-12,0>} 
	object {Weird_Ring2 translate <0,-24,0>}
	object {Weird_Ring2 translate <0,-36,0>}
}  

#declare Tower2 = 
union {
	TW_One (3.1,500,3,.5,1) 
	RT_Main (10,1,3,1.5,2) 
	
	object {Weird_Ring1 translate <0,-7,0>} 
	object {Weird_Ring1 translate <0,-14,0>}
	object {Weird_Ring1 translate <0,-21,0>} 
	object {Weird_Ring1 translate <0,-28,0>}
} 

#declare Tower3 = 
union {
	TW_One (3.1,500,3,.8,1) 
	RT_Main (10,1,3,1.5,2) 
	
	object {Weird_Ring1 translate <0,-10,0>} 
	object {Weird_Ring1 translate <0,-20,0>}
	object {Weird_Ring1 translate <0,-30,0>} 
	object {Weird_Ring1 translate <0,-40,0>} 
	object {Weird_Ring1 translate <0,-50,0>}
}

